import java.io.*;
import java.util.*;

public class subsegment_ma_n4_java {
    String fileName = "";

    public void solve() throws IOException {
        int n = nextInt();
        long c = nextLong();
        char[] s = nextToken().toCharArray();
        int mx = 0;
        for (int i = 0; i < n; i++) {
            for (int j = i; j < n; j++) {
                int cnt = 0;
                for (int k = i; k <= j; k++) {
                    for (int l = k + 1; l <= j; l++) {
                        if (s[k] == 'a' && s[l] == 'b') {
                            cnt++;
                        }
                    }
                }
                if (cnt <= c) {
                    mx = Math.max(mx, j - i + 1);
                }
            }
        }

        out.println(mx);
    }

    public void run() {
        try {
            if (fileName.equals("")) {
                br = new BufferedReader(new InputStreamReader(System.in));
                out = new PrintWriter(System.out);
            } else if (fileName.equals("txt")) {
                br = new BufferedReader(new FileReader("input.txt"));
                out = new PrintWriter("output.txt");
            } else {
                br = new BufferedReader(new FileReader(fileName + ".in"));
                out = new PrintWriter(fileName + ".out");
            }

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new subsegment_ma_n4_java().run();
    }

}