#include "bits/stdc++.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }

const int MAXV = 1 << 20, mask = (1 << 20) - 1;

int rsq[MAXV * 2];
int bpv = MAXV;

int s_get(int v, int vl, int vr, int l, int r) {
	if (vr <= l || r <= vl) {
		return 0;
	}
	if (l <= vl && vr <= r) {
		return rsq[v];
	}
	int vm = (vl + vr) / 2;
	return s_get(v * 2, vl, vm, l, r) + s_get(v * 2 + 1, vm, vr, l, r);
}

void solve() {
	int n, q;
	cin >> n >> q;
	vector<int> inp;
	for (int i = 0; i < n; ++i) {
		int num;
		cin >> num;
		inp.push_back(num);
		rsq[num + bpv]++;
	}

	for (int i = bpv - 1; i; --i) {
		rsq[i] = rsq[i * 2] + rsq[i * 2 + 1];
	}

	int defined_mask = 0, undefined_mask = mask;
	int defined_value = 0;
	int vals_xor = 0;
	for (int i = 0; i < q; ++i) {
		string s;
		cin >> s;
		//cerr << defined_mask << " " << defined_value << endl;
		if (s == "and") {
			int num;
			cin >> num;
			int not_num = (~num) & mask;
			if ((defined_mask & not_num) != not_num) {
				defined_mask |= not_num;
				undefined_mask &= num;
				defined_value &= num;
				fill(rsq, rsq + bpv * 2, 0);
				//cerr << "new vals: ";
				for (int& val : inp) {
					val ^= vals_xor;
					val &= num;
					//cerr << val << " ";
					rsq[val + bpv]++;
				}
				for (int j = bpv - 1; j; --j) {
					rsq[j] = rsq[j * 2] + rsq[j * 2 + 1];
				}
				//cerr << endl;
				vals_xor = 0;
			} else {
				defined_value &= num;
			}
		} else if (s == "xor") {
			int num;
			cin >> num;
			vals_xor ^= num & undefined_mask;
			defined_value ^= num & defined_mask;
		} else {
			int l, r;
			cin >> l >> r;
			l -= defined_value;
			r -= defined_value;
			
			cout << s_get(1, 0, bpv, l, r + 1) << "\n";
		}
	}
}


int main() {
	//freopen(TASK_NAME ".in", "r", stdin);
	//freopen(TASK_NAME ".out", "w", stdout);
	cerr << fixed << setprecision(15);
	cout << fixed << setprecision(15);
	ios::sync_with_stdio(false);

	int tests = 1;
	// cin >> tests;
	for (int it = 1; it <= tests; ++it) {
		solve();
	}
	
	#ifdef LOCAL
		cerr << "time: " << clock() << " ms\n";
	#endif
	return 0;
}