#include <cmath>
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <list>
#include <time.h>
#include <math.h>
#include <random>
#include <deque>
#include <queue>
#include <cassert>
#include <unordered_map>
#include <iomanip>
#include <bitset>

using namespace std;

typedef long long ll;

mt19937 rnd(228);

int main()
{
#ifdef ONPC
    freopen("a.in", "r", stdin);
#endif
    int n;
    cin >> n;
    string s;
    cin >> s;
    int m, a, b;
    cin >> m >> a >> b;
    vector <int> dp(n + 1);
    vector <int> cnt(n + 1);
    int ans = 0;
    for (int i = n - 1; i >= 0; i--)
    {
        if (s[i] == '1')
        {
            cnt[i] = cnt[i + 1] + 1;
        }
        else
        {
            cnt[i] = 0;
        }
        if (cnt[i] >= a && i + a + b - 1 < n)
        {
            dp[i] = dp[i + a + b] + 1;
        }
        else
        {
            dp[i] = 0;
        }
        if (dp[i] >= m)
        {
            ans++;
        }
    }
    cout << ans << '\n';
}
