#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

                                                
string check(int n, int m, vector<int>& p, InStream& in) 
{
    vector<int> a(n);
    a[0] = in.readInt();
    if (a[0] == -1)
        return "-1";
    for (int i = 1; i < n; i++)
        a[i] = in.readInt();
    int cur_sum = 0;
    for (int i = 0; i < n; i++)
    {
        if (a[i] < m)
            in.quitf(_wa, "a[%d]=%d < m=%d", i + 1, a[i], m);    
        cur_sum += a[i];
        if (p[i] != -1 && p[i] != cur_sum)
            in.quitf(_wa, "Wrong prefix sum %d", i + 1);
    }
    return "ok";
}

int main(int argc, char* argv[]) 
{
    registerTestlibCmd(argc, argv);
    int n = inf.readInt();
    int m = inf.readInt();
    vector<int> p(n);
    for (int i = 0; i < n; i++)
        p[i] = inf.readInt();
    string jans = check(n, m, p, ans);
    string cans = check(n, m, p, ouf);
    if (jans != cans) 
    {
        if (jans == "-1")
            quitf(_fail, "Participant find answer but jury not");
        else
            quitf(_wa, "Jury find answer but participant not");
    }
    quitf(_ok, "n=%d, m=%d", n, m);
    return 0;
}
