#include "testlib.h"
#include <string>

using namespace std;

int MAXN[] = {1000000, 3, 50, 700, 5000, 100000, 1000000};
const long long MAXC = 1000000000000000000LL;

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);

    int gr = 0;
    if (!validator.group().empty()) {
        gr = validator.group()[0] - '0';
    }

    int n = inf.readInt(1, MAXN[gr], "n");
    inf.readSpace();
    long long c = inf.readLong(0, MAXC, "c");
    inf.readEoln();

    string s = inf.readToken("[a-z]+");
    ensuref(s.length() == n, "length of s is not equal to n");

    inf.readEoln();
    inf.readEof();
}
