#include "bits/stdc++.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }

const int MAXV = 1 << 20;
int amount[MAXV];


void solve() {
	int n, q;
	cin >> n >> q;
	vector<int> inp;
	for (int i = 0; i < n; ++i) {
		int num;
		cin >> num;
		inp.push_back(num);
		amount[num]++;
	}
	int all_xor = 0;
	for (int i = 0; i < q; ++i) {
		string type;
		cin >> type;
		if (type == "and") {
			int num;
			cin >> num;
			fill(amount, amount + MAXV, 0);
			for (int& val : inp) {
				val ^= all_xor;
				val &= num;
				amount[val]++;
			}
		} else if (type == "xor") {
			int num;
			cin >> num;
			all_xor ^= num;
		} else {
			int l, r;
			cin >> l >> r;
			cout << amount[l ^ all_xor] << "\n";
		}
	}
}


int main() {
	//freopen(TASK_NAME ".in", "r", stdin);
	//freopen(TASK_NAME ".out", "w", stdout);
	cerr << fixed << setprecision(15);
	cout << fixed << setprecision(15);
	ios::sync_with_stdio(false);

	int tests = 1;
	// cin >> tests;
	for (int it = 1; it <= tests; ++it) {
		solve();
	}
	
	#ifdef LOCAL
		cerr << "time: " << clock() << " ms\n";
	#endif
	return 0;
}